#include<stdio.h>
#include<stdlib.h>
#include "cquad.h"

double fun(double x);

int main()
{
 double bound, epsabs, epsrel, result, abserr, *alist, *blist, *rlist, *elist;
 int neval, ier, inf, last, *iord;

 // bound and inf determine the integration limits
    bound = 0.0;
    inf = 1;

 // epsabs and epsrel determine the accuracy requirement    
    epsabs = 0.0;
    epsrel = 0.001;

 // allocate memory
    iord = (int *) calloc(LIMIT, sizeof(int));
    alist = (double *) calloc(LIMIT, sizeof(double));
    blist = (double *) calloc(LIMIT, sizeof(double));
    rlist = (double *) calloc(LIMIT, sizeof(double));
    elist = (double *) calloc(LIMIT, sizeof(double));

    result = cquad_dqagie(fun, bound, inf, epsabs, epsrel, &abserr, &neval, &ier, alist, blist, rlist, elist, iord, &last);

 // print the result
    printf("\nFunction:  log(x) / (1 + 100x²)  over [0, +inf]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iord);
    free(alist);
    free(blist);
    free(rlist);
    free(elist);
}
