#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, b, epsabs, epsrel, result, abserr, alfa, beta, *work;
    int neval, ier, integr, last, *iwork;
 
 // a and b are the integration limits
    a = 0.0;
    b = 1.0;

 // alfa, beta and integr determine the weight function
    alfa = 0.0;
    beta = 0.0;
    integr = 2;

 // epsabs and epsrel determine the accuracy requirement
    epsabs = 0;
    epsrel = 0.001;

 // allocate memory
    iwork = (int *) calloc(LIMIT, sizeof(int));
    work = (double *) calloc(LENW, sizeof(double));

    result = cquad_dqaws(fun, a, b, alfa, beta, integr, epsabs, epsrel, &abserr, &neval, &ier, &last, iwork, work);

 // print the result
    printf("\nFunction:  log(x) / (1 + (ln(x))²)²  over [0, 1]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iwork);
    free(work);
}
